diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/test/val-array-test-suite.cc ns-3.39/src/core/test/val-array-test-suite.cc
--- ns-3.38/src/core/test/val-array-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/core/test/val-array-test-suite.cc	2023-07-05 14:23:47.773427200 -0700
@@ -48,7 +48,7 @@
      *
      * \param [in] name reference name
      */
-    ValArrayTestCase<T>(const std::string name);
+    ValArrayTestCase<T>(const std::string& name);
 
     /** Destructor. */
     ~ValArrayTestCase<T>() override;
@@ -80,7 +80,7 @@
 };
 
 template <class T>
-ValArrayTestCase<T>::ValArrayTestCase(const std::string name)
+ValArrayTestCase<T>::ValArrayTestCase(const std::string& name)
     : TestCase(name)
 {
 }
@@ -95,9 +95,9 @@
 ValArrayTestCase<T>::DoRun()
 {
     ValArray<T> v1 = ValArray<T>(2, 3);
-    for (uint16_t i = 0; i < v1.GetNumRows(); ++i)
+    for (size_t i = 0; i < v1.GetNumRows(); ++i)
     {
-        for (uint16_t j = 0; j < v1.GetNumCols(); ++j)
+        for (size_t j = 0; j < v1.GetNumCols(); ++j)
         {
             v1(i, j) = 1;
         }
@@ -108,9 +108,9 @@
     NS_TEST_ASSERT_MSG_EQ(v1.GetNumCols(), v2.GetNumCols(), "The number of cols are not equal.");
 
     // test copy constructor
-    for (uint16_t i = 0; i < v1.GetNumRows(); ++i)
+    for (size_t i = 0; i < v1.GetNumRows(); ++i)
     {
-        for (uint16_t j = 0; j < v1.GetNumCols(); ++j)
+        for (size_t j = 0; j < v1.GetNumCols(); ++j)
         {
             NS_TEST_ASSERT_MSG_EQ(v1(i, j), v2(i, j), "The elements are not equal.");
         }
@@ -120,9 +120,9 @@
     ValArray<T> v3 = v1;
     NS_TEST_ASSERT_MSG_EQ(v1.GetNumRows(), v3.GetNumRows(), "The number of rows are not equal.");
     NS_TEST_ASSERT_MSG_EQ(v1.GetNumCols(), v3.GetNumCols(), "The number of cols are not equal.");
-    for (uint16_t i = 0; i < v1.GetNumRows(); ++i)
+    for (size_t i = 0; i < v1.GetNumRows(); ++i)
     {
-        for (uint16_t j = 0; j < v1.GetNumCols(); ++j)
+        for (size_t j = 0; j < v1.GetNumCols(); ++j)
         {
             NS_TEST_ASSERT_MSG_EQ(v1(i, j), v2(i, j), "The elements are not equal.");
         }
@@ -136,9 +136,9 @@
     v4 = std::move(v1);
     NS_LOG_INFO("v4 size after move: " << v4.GetSize());
     NS_TEST_ASSERT_MSG_EQ(v1size, v4.GetSize(), "The number of elements are not equal.");
-    for (uint16_t i = 0; i < v4.GetNumRows(); ++i)
+    for (size_t i = 0; i < v4.GetNumRows(); ++i)
     {
-        for (uint16_t j = 0; j < v4.GetNumCols(); ++j)
+        for (size_t j = 0; j < v4.GetNumCols(); ++j)
         {
             // Use v3 for comparison since it hasn't moved
             NS_TEST_ASSERT_MSG_EQ(v3(i, j), v4(i, j), "The elements are not equal.");
@@ -150,9 +150,9 @@
     size_t v3size = v3.GetSize();
     ValArray<T> v5(std::move(v3));
     NS_TEST_ASSERT_MSG_EQ(v3size, v5.GetSize(), "The number of elements are not equal.");
-    for (uint16_t i = 0; i < v5.GetNumRows(); ++i)
+    for (size_t i = 0; i < v5.GetNumRows(); ++i)
     {
-        for (uint16_t j = 0; j < v5.GetNumCols(); ++j)
+        for (size_t j = 0; j < v5.GetNumCols(); ++j)
         {
             // Use v4 for comparison since it hasn't moved
             NS_TEST_ASSERT_MSG_EQ(v4(i, j), v5(i, j), "The elements are not equal.");
@@ -177,10 +177,10 @@
     // test whether column-major order was respected during the initialization and
     // also in the access operator if we iterate over rows first we should find 0, 2, 4, 6, ...
     std::valarray<int> initArray2{0, 2, 4, 6, 1, 3, 5, 7};
-    auto testIndex = 0;
-    for (uint16_t i = 0; i < v6.GetNumRows(); ++i)
+    size_t testIndex = 0;
+    for (size_t i = 0; i < v6.GetNumRows(); ++i)
     {
-        for (uint16_t j = 0; j < v6.GetNumCols(); ++j)
+        for (size_t j = 0; j < v6.GetNumCols(); ++j)
         {
             NS_TEST_ASSERT_MSG_EQ(v6(i, j),
                                   static_cast<T>(initArray2[testIndex]),
@@ -203,11 +203,11 @@
     // if we iterate over rows first we should find 0, 2, 4, 6, ...
     std::valarray<int> initArray4{0, 2, 4, 6, 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7};
     testIndex = 0;
-    for (uint16_t p = 0; p < v7.GetNumPages(); ++p)
+    for (size_t p = 0; p < v7.GetNumPages(); ++p)
     {
-        for (uint16_t i = 0; i < v7.GetNumRows(); ++i)
+        for (size_t i = 0; i < v7.GetNumRows(); ++i)
         {
-            for (uint16_t j = 0; j < v7.GetNumCols(); ++j)
+            for (size_t j = 0; j < v7.GetNumCols(); ++j)
             {
                 NS_TEST_ASSERT_MSG_EQ(v7(i, j, p),
                                       static_cast<T>(initArray4[testIndex]),
@@ -219,11 +219,11 @@
 
     // multiplication with a scalar value with 3D array
     ValArray<T> v8 = v7 * (static_cast<T>(5.0));
-    for (uint16_t p = 0; p < v8.GetNumPages(); ++p)
+    for (size_t p = 0; p < v8.GetNumPages(); ++p)
     {
-        for (uint16_t i = 0; i < v8.GetNumRows(); ++i)
+        for (size_t i = 0; i < v8.GetNumRows(); ++i)
         {
-            for (uint16_t j = 0; j < v8.GetNumCols(); ++j)
+            for (size_t j = 0; j < v8.GetNumCols(); ++j)
             {
                 NS_TEST_ASSERT_MSG_EQ(v7(i, j, p) * (static_cast<T>(5.0)),
                                       v8(i, j, p),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/csma/model/csma-channel.cc ns-3.39/src/csma/model/csma-channel.cc
--- ns-3.38/src/csma/model/csma-channel.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/csma/model/csma-channel.cc	2023-07-05 14:23:47.773427200 -0700
@@ -310,14 +310,7 @@
 bool
 CsmaChannel::IsBusy()
 {
-    if (m_state == IDLE)
-    {
-        return false;
-    }
-    else
-    {
-        return true;
-    }
+    return m_state != IDLE;
 }
 
 DataRate
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/csma/model/csma-net-device.cc ns-3.39/src/csma/model/csma-net-device.cc
--- ns-3.38/src/csma/model/csma-net-device.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/csma/model/csma-net-device.cc	2023-07-05 14:23:47.773427200 -0700
@@ -459,7 +459,7 @@
     //
     // Only transmit if the send side of net device is enabled
     //
-    if (IsSendEnabled() == false)
+    if (!IsSendEnabled())
     {
         m_phyTxDropTrace(m_currentPkt);
         m_currentPkt = nullptr;
@@ -512,7 +512,7 @@
         // The channel is free, transmit the packet
         //
         m_phyTxBeginTrace(m_currentPkt);
-        if (m_channel->TransmitStart(m_currentPkt, m_deviceId) == false)
+        if (!m_channel->TransmitStart(m_currentPkt, m_deviceId))
         {
             NS_LOG_WARN("Channel TransmitStart returns an error");
             m_phyTxDropTrace(m_currentPkt);
@@ -718,7 +718,7 @@
     //
     // Only receive if the send side of net device is enabled
     //
-    if (IsReceiveEnabled() == false)
+    if (!IsReceiveEnabled())
     {
         m_phyRxDropTrace(packet);
         return;
@@ -974,7 +974,7 @@
     //
     // Only transmit if send side of net device is enabled
     //
-    if (IsSendEnabled() == false)
+    if (!IsSendEnabled())
     {
         m_macTxDropTrace(packet);
         return false;
@@ -990,7 +990,7 @@
     // Place the packet to be sent on the send queue.  Note that the
     // queue may fire a drop trace, but we will too.
     //
-    if (m_queue->Enqueue(packet) == false)
+    if (!m_queue->Enqueue(packet))
     {
         m_macTxDropTrace(packet);
         return false;
@@ -1003,7 +1003,7 @@
     //
     if (m_txMachineState == READY)
     {
-        if (m_queue->IsEmpty() == false)
+        if (!m_queue->IsEmpty())
         {
             Ptr<Packet> packet = m_queue->Dequeue();
             NS_ASSERT_MSG(packet,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/csma/test/examples-to-run.py ns-3.39/src/csma/test/examples-to-run.py
--- ns-3.38/src/csma/test/examples-to-run.py	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/csma/test/examples-to-run.py	2023-07-05 14:23:47.773427200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsdv/examples/dsdv-manet.cc ns-3.39/src/dsdv/examples/dsdv-manet.cc
--- ns-3.38/src/dsdv/examples/dsdv-manet.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/dsdv/examples/dsdv-manet.cc	2023-07-05 14:23:47.773427200 -0700
@@ -29,7 +29,6 @@
  */
 
 #include "ns3/applications-module.h"
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/dsdv-helper.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsdv/model/dsdv-routing-protocol.cc ns-3.39/src/dsdv/model/dsdv-routing-protocol.cc
--- ns-3.38/src/dsdv/model/dsdv-routing-protocol.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/dsdv/model/dsdv-routing-protocol.cc	2023-07-05 14:23:47.773427200 -0700
@@ -391,10 +391,10 @@
 RoutingProtocol::RouteInput(Ptr<const Packet> p,
                             const Ipv4Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb)
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(m_mainAddress << " received packet " << p->GetUid() << " from "
                                   << header.GetSource() << " on interface " << idev->GetAddress()
@@ -419,7 +419,7 @@
     }
 
     // Deferred route request
-    if (EnableBuffering == true && idev == m_lo)
+    if (EnableBuffering && idev == m_lo)
     {
         DeferredRouteOutputTag tag;
         if (p->PeekPacketTag(tag))
@@ -449,7 +449,7 @@
             if (dst == iface.GetBroadcast() || dst.IsBroadcast())
             {
                 Ptr<Packet> packet = p->Copy();
-                if (lcb.IsNull() == false)
+                if (!lcb.IsNull())
                 {
                     NS_LOG_LOGIC("Broadcast local delivery to " << iface.GetLocal());
                     lcb(p, header, iif);
@@ -482,7 +482,7 @@
 
     if (m_ipv4->IsDestinationAddress(dst, iif))
     {
-        if (lcb.IsNull() == false)
+        if (!lcb.IsNull())
         {
             NS_LOG_LOGIC("Unicast local delivery to " << dst);
             lcb(p, header, iif);
@@ -497,7 +497,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv4->IsForwarding(iif) == false)
+    if (!m_ipv4->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         ecb(p, header, Socket::ERROR_NOROUTETOHOST);
@@ -627,7 +627,7 @@
         EventId event;
         bool permanentTableVerifier =
             m_routingTable.LookupRoute(dsdvHeader.GetDst(), fwdTableEntry);
-        if (permanentTableVerifier == false)
+        if (!permanentTableVerifier)
         {
             if (dsdvHeader.GetDstSeqno() % 2 != 1)
             {
@@ -860,8 +860,8 @@
                                          << " SeqNo:" << i->second.GetSeqNo()
                                          << " HopCount:" << i->second.GetHop() + 1);
             RoutingTableEntry temp = i->second;
-            if ((i->second.GetEntriesChanged() == true) &&
-                (!m_advRoutingTable.AnyRunningEvent(temp.GetDestination())))
+            if (i->second.GetEntriesChanged() &&
+                !m_advRoutingTable.AnyRunningEvent(temp.GetDestination()))
             {
                 dsdvHeader.SetDst(i->second.GetDestination());
                 dsdvHeader.SetDstSeqno(i->second.GetSeqNo());
@@ -1287,8 +1287,8 @@
              ++i)
         {
             RoutingTableEntry advEntry = i->second;
-            if ((advEntry.GetEntriesChanged() == true) &&
-                (!m_advRoutingTable.AnyRunningEvent(advEntry.GetDestination())))
+            if (advEntry.GetEntriesChanged() &&
+                !m_advRoutingTable.AnyRunningEvent(advEntry.GetDestination()))
             {
                 if (!(advEntry.GetSeqNo() % 2))
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsdv/model/dsdv-routing-protocol.h ns-3.39/src/dsdv/model/dsdv-routing-protocol.h
--- ns-3.38/src/dsdv/model/dsdv-routing-protocol.h	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/dsdv/model/dsdv-routing-protocol.h	2023-07-05 14:23:47.773427200 -0700
@@ -87,10 +87,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void PrintRoutingTable(Ptr<OutputStreamWrapper> stream,
                            Time::Unit unit = Time::S) const override;
     void NotifyInterfaceUp(uint32_t interface) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsdv/model/dsdv-rtable.cc ns-3.39/src/dsdv/model/dsdv-rtable.cc
--- ns-3.38/src/dsdv/model/dsdv-rtable.cc	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/dsdv/model/dsdv-rtable.cc	2023-07-05 14:23:47.773427200 -0700
@@ -101,7 +101,7 @@
     {
         return false;
     }
-    if (forRouteInput == true && id == i->second.GetInterface().GetBroadcast())
+    if (forRouteInput && id == i->second.GetInterface().GetBroadcast())
     {
         return false;
     }
@@ -112,12 +112,7 @@
 bool
 RoutingTable::DeleteRoute(Ipv4Address dst)
 {
-    if (m_ipv4AddressEntry.erase(dst) != 0)
-    {
-        // NS_LOG_DEBUG("Route erased");
-        return true;
-    }
-    return false;
+    return m_ipv4AddressEntry.erase(dst) != 0;
 }
 
 uint32_t
@@ -329,14 +324,7 @@
         return false;
     }
     event = i->second;
-    if (event.IsRunning())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return event.IsRunning();
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsdv/model/dsdv-rtable.h ns-3.39/src/dsdv/model/dsdv-rtable.h
--- ns-3.38/src/dsdv/model/dsdv-rtable.h	2023-03-16 20:54:23.600868500 -0700
+++ ns-3.39/src/dsdv/model/dsdv-rtable.h	2023-07-05 14:23:47.773427200 -0700
@@ -353,7 +353,7 @@
      * \param id destination address
      * \param rt entry with destination address dst, if exists
      * \param forRouteInput for routing input
-     * \return true on success
+     * \return true onns3  success
      */
     bool LookupRoute(Ipv4Address id, RoutingTableEntry& rt, bool forRouteInput);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-gratuitous-reply-table.h ns-3.39/src/dsr/model/dsr-gratuitous-reply-table.h
--- ns-3.38/src/dsr/model/dsr-gratuitous-reply-table.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-gratuitous-reply-table.h	2023-07-05 14:23:47.777427200 -0700
@@ -132,7 +132,7 @@
          * \param b GraReplyEntry entry
          * \return true if expired, false otherwise
          */
-        bool operator()(const struct GraReplyEntry& b) const
+        bool operator()(const GraReplyEntry& b) const
         {
             return (b.m_gratReplyHoldoff < Simulator::Now());
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-option-header.cc ns-3.39/src/dsr/model/dsr-option-header.cc
--- ns-3.38/src/dsr/model/dsr-option-header.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-option-header.cc	2023-07-05 14:23:47.777427200 -0700
@@ -417,14 +417,11 @@
     m_identification = i.ReadNtohU16();
     ReadFrom(i, m_target);
 
-    uint8_t index = 0;
-    for (std::vector<Ipv4Address>::iterator it = m_ipv4Address.begin(); it != m_ipv4Address.end();
-         it++)
+    for (std::size_t index = 0; index < m_ipv4Address.size(); index++)
     {
         i.Read(buff, 4);
-        m_address = it->Deserialize(buff);
-        SetNodeAddress(index, m_address);
-        ++index;
+        m_address = Ipv4Address::Deserialize(buff);
+        SetNodeAddress(static_cast<uint8_t>(index), m_address);
     }
 
     return GetSerializedSize();
@@ -555,14 +552,11 @@
     i.ReadU8();
     i.ReadU8();
 
-    uint8_t index = 0;
-    for (std::vector<Ipv4Address>::iterator it = m_ipv4Address.begin(); it != m_ipv4Address.end();
-         it++)
+    for (std::size_t index = 0; index < m_ipv4Address.size(); index++)
     {
         i.Read(buff, 4);
-        m_address = it->Deserialize(buff);
-        SetNodeAddress(index, m_address);
-        ++index;
+        m_address = Ipv4Address::Deserialize(buff);
+        SetNodeAddress(static_cast<uint8_t>(index), m_address);
     }
 
     return GetSerializedSize();
@@ -718,14 +712,11 @@
     m_salvage = i.ReadU8();
     m_segmentsLeft = i.ReadU8();
 
-    uint8_t index = 0;
-    for (std::vector<Ipv4Address>::iterator it = m_ipv4Address.begin(); it != m_ipv4Address.end();
-         it++)
+    for (std::size_t index = 0; index < m_ipv4Address.size(); index++)
     {
         i.Read(buff, 4);
-        m_address = it->Deserialize(buff);
-        SetNodeAddress(index, m_address);
-        ++index;
+        m_address = Ipv4Address::Deserialize(buff);
+        SetNodeAddress(static_cast<uint8_t>(index), m_address);
     }
 
     return GetSerializedSize();
@@ -1018,25 +1009,25 @@
     return retVal;
 }
 
-NS_OBJECT_ENSURE_REGISTERED(DsrOptionRerrUnsupportHeader);
+NS_OBJECT_ENSURE_REGISTERED(DsrOptionRerrUnsupportedHeader);
 
 TypeId
-DsrOptionRerrUnsupportHeader::GetTypeId()
+DsrOptionRerrUnsupportedHeader::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::dsr::DsrOptionRerrUnsupportHeader")
-                            .AddConstructor<DsrOptionRerrUnsupportHeader>()
+    static TypeId tid = TypeId("ns3::dsr::DsrOptionRerrUnsupportedHeader")
+                            .AddConstructor<DsrOptionRerrUnsupportedHeader>()
                             .SetParent<DsrOptionRerrHeader>()
                             .SetGroupName("Dsr");
     return tid;
 }
 
 TypeId
-DsrOptionRerrUnsupportHeader::GetInstanceTypeId() const
+DsrOptionRerrUnsupportedHeader::GetInstanceTypeId() const
 {
     return GetTypeId();
 }
 
-DsrOptionRerrUnsupportHeader::DsrOptionRerrUnsupportHeader()
+DsrOptionRerrUnsupportedHeader::DsrOptionRerrUnsupportedHeader()
     : m_salvage(0)
 {
     SetType(3);
@@ -1044,60 +1035,60 @@
     SetErrorType(3);
 }
 
-DsrOptionRerrUnsupportHeader::~DsrOptionRerrUnsupportHeader()
+DsrOptionRerrUnsupportedHeader::~DsrOptionRerrUnsupportedHeader()
 {
 }
 
 void
-DsrOptionRerrUnsupportHeader::SetSalvage(uint8_t salvage)
+DsrOptionRerrUnsupportedHeader::SetSalvage(uint8_t salvage)
 {
     m_salvage = salvage;
 }
 
 uint8_t
-DsrOptionRerrUnsupportHeader::GetSalvage() const
+DsrOptionRerrUnsupportedHeader::GetSalvage() const
 {
     return m_salvage;
 }
 
 void
-DsrOptionRerrUnsupportHeader::SetErrorSrc(Ipv4Address errorSrcAddress)
+DsrOptionRerrUnsupportedHeader::SetErrorSrc(Ipv4Address errorSrcAddress)
 {
     m_errorSrcAddress = errorSrcAddress;
 }
 
 Ipv4Address
-DsrOptionRerrUnsupportHeader::GetErrorSrc() const
+DsrOptionRerrUnsupportedHeader::GetErrorSrc() const
 {
     return m_errorSrcAddress;
 }
 
 void
-DsrOptionRerrUnsupportHeader::SetErrorDst(Ipv4Address errorDstAddress)
+DsrOptionRerrUnsupportedHeader::SetErrorDst(Ipv4Address errorDstAddress)
 {
     m_errorDstAddress = errorDstAddress;
 }
 
 Ipv4Address
-DsrOptionRerrUnsupportHeader::GetErrorDst() const
+DsrOptionRerrUnsupportedHeader::GetErrorDst() const
 {
     return m_errorDstAddress;
 }
 
 void
-DsrOptionRerrUnsupportHeader::SetUnsupported(uint16_t unsupported)
+DsrOptionRerrUnsupportedHeader::SetUnsupported(uint16_t unsupported)
 {
     m_unsupported = unsupported;
 }
 
 uint16_t
-DsrOptionRerrUnsupportHeader::GetUnsupported() const
+DsrOptionRerrUnsupportedHeader::GetUnsupported() const
 {
     return m_unsupported;
 }
 
 void
-DsrOptionRerrUnsupportHeader::Print(std::ostream& os) const
+DsrOptionRerrUnsupportedHeader::Print(std::ostream& os) const
 {
     os << "( type = " << (uint32_t)GetType() << " length = " << (uint32_t)GetLength()
        << " errorType = " << (uint32_t)m_errorType << " salvage = " << (uint32_t)m_salvage
@@ -1106,13 +1097,13 @@
 }
 
 uint32_t
-DsrOptionRerrUnsupportHeader::GetSerializedSize() const
+DsrOptionRerrUnsupportedHeader::GetSerializedSize() const
 {
     return 16;
 }
 
 void
-DsrOptionRerrUnsupportHeader::Serialize(Buffer::Iterator start) const
+DsrOptionRerrUnsupportedHeader::Serialize(Buffer::Iterator start) const
 {
     Buffer::Iterator i = start;
 
@@ -1126,7 +1117,7 @@
 }
 
 uint32_t
-DsrOptionRerrUnsupportHeader::Deserialize(Buffer::Iterator start)
+DsrOptionRerrUnsupportedHeader::Deserialize(Buffer::Iterator start)
 {
     Buffer::Iterator i = start;
 
@@ -1142,7 +1133,7 @@
 }
 
 DsrOptionHeader::Alignment
-DsrOptionRerrUnsupportHeader::GetAlignment() const
+DsrOptionRerrUnsupportedHeader::GetAlignment() const
 {
     Alignment retVal = {4, 0};
     return retVal;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-option-header.h ns-3.39/src/dsr/model/dsr-option-header.h
--- ns-3.38/src/dsr/model/dsr-option-header.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-option-header.h	2023-07-05 14:23:47.777427200 -0700
@@ -1028,7 +1028,7 @@
    \endverbatim
  */
 
-class DsrOptionRerrUnsupportHeader : public DsrOptionRerrHeader
+class DsrOptionRerrUnsupportedHeader : public DsrOptionRerrHeader
 {
   public:
     /**
@@ -1044,11 +1044,11 @@
     /**
      * \brief Constructor.
      */
-    DsrOptionRerrUnsupportHeader();
+    DsrOptionRerrUnsupportedHeader();
     /**
      * \brief Destructor.
      */
-    ~DsrOptionRerrUnsupportHeader() override;
+    ~DsrOptionRerrUnsupportedHeader() override;
     /**
      * \brief Set the route error source address
      * \param errorSrcAddress The error source address
@@ -1335,7 +1335,7 @@
     Ipv4Address m_realDstAddress;
 };
 
-static inline std::ostream&
+[[maybe_unused]] static inline std::ostream&
 operator<<(std::ostream& os, const DsrOptionSRHeader& sr)
 {
     sr.Print(os);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/dsr/model/dsr-options.cc ns-3.39/src/dsr/model/dsr-options.cc
--- ns-3.38/src/dsr/model/dsr-options.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/dsr/model/dsr-options.cc	2023-07-05 14:23:47.777427200 -0700
@@ -58,6 +58,7 @@
 #include "ns3/udp-header.h"
 #include "ns3/uinteger.h"
 
+#include <algorithm>
 #include <ctime>
 #include <list>
 #include <map>
@@ -164,18 +165,10 @@
 DsrOptions::ReverseRoutes(std::vector<Ipv4Address>& vec)
 {
     NS_LOG_FUNCTION(this);
-    std::vector<Ipv4Address> vec2(vec);
-    vec.clear(); // To ensure vec is empty before start
-    for (std::vector<Ipv4Address>::reverse_iterator ri = vec2.rbegin(); ri != vec2.rend(); ++ri)
-    {
-        vec.push_back(*ri);
-    }
 
-    if ((vec.size() == vec2.size()) && (vec.front() == vec2.back()))
-    {
-        return true;
-    }
-    return false;
+    std::reverse(vec.begin(), vec.end());
+
+    return true;
 }
 
 Ipv4Address
@@ -190,23 +183,22 @@
         nextHop = vec[1];
         return nextHop;
     }
-    else
+
+    if (ipv4Address == vec.back())
     {
-        if (ipv4Address == vec.back())
-        {
-            NS_LOG_DEBUG("We have reached to the final destination " << ipv4Address << " "
-                                                                     << vec.back());
-            return ipv4Address;
-        }
-        for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+        NS_LOG_DEBUG("We have reached to the final destination " << ipv4Address << " "
+                                                                 << vec.back());
+        return ipv4Address;
+    }
+    for (std::vector<Ipv4Address>::const_iterator i = vec.begin(); i != vec.end(); ++i)
+    {
+        if (ipv4Address == (*i))
         {
-            if (ipv4Address == (*i))
-            {
-                nextHop = *(++i);
-                return nextHop;
-            }
+            nextHop = *(++i);
+            return nextHop;
         }
     }
+
     NS_LOG_DEBUG("next hop address not found, route corrupted");
     Ipv4Address none = "0.0.0.0";
     return none;
@@ -223,17 +215,16 @@
         nextHop = vec[0];
         return nextHop;
     }
-    else
+
+    for (std::vector<Ipv4Address>::reverse_iterator ri = vec.rbegin(); ri != vec.rend(); ++ri)
     {
-        for (std::vector<Ipv4Address>::reverse_iterator ri = vec.rbegin(); ri != vec.rend(); ++ri)
+        if (ipv4Address == (*ri))
         {
-            if (ipv4Address == (*ri))
-            {
-                nextHop = *(++ri);
-                return nextHop;
-            }
+            nextHop = *(++ri);
+            return nextHop;
         }
     }
+
     NS_LOG_DEBUG("next hop address not found, route corrupted");
     Ipv4Address none = "0.0.0.0";
     return none;
@@ -292,10 +283,6 @@
             {
                 return true;
             }
-            else
-            {
-                continue;
-            }
         }
     }
     return false;
@@ -311,10 +298,6 @@
         {
             return true;
         }
-        else
-        {
-            continue;
-        }
     }
     return false;
 }
@@ -335,31 +318,22 @@
             vec.push_back(*i);
             continue;
         }
-        else
+
+        for (std::vector<Ipv4Address>::iterator j = vec.begin(); j != vec.end(); ++j)
         {
-            for (std::vector<Ipv4Address>::iterator j = vec.begin(); j != vec.end(); ++j)
+            if ((*i) == (*j))
             {
-                if ((*i) == (*j))
-                {
-                    if ((j + 1) != vec.end())
-                    {
-                        vec.erase(j + 1, vec.end()); // Automatic shorten the route
-                        break;
-                    }
-                    else
-                    {
-                        break;
-                    }
-                }
-                else if (j == (vec.end() - 1))
-                {
-                    vec.push_back(*i);
-                    break;
-                }
-                else
+                if ((j + 1) != vec.end())
                 {
-                    continue;
+                    vec.erase(j + 1, vec.end()); // Automatic shorten the route
                 }
+
+                break;
+            }
+            else if (j == (vec.end() - 1))
+            {
+                vec.push_back(*i);
+                break;
             }
         }
     }
@@ -1634,12 +1608,12 @@
         /*
          * Remove the route error header from the packet, and get the error type
          */
-        DsrOptionRerrUnsupportHeader rerrUnsupport;
-        p->RemoveHeader(rerrUnsupport);
+        DsrOptionRerrUnsupportedHeader rerrUnsupported;
+        p->RemoveHeader(rerrUnsupported);
 
         /// \todo This is for the other two error options, not supporting for now
-        // uint32_t rerrSize = rerrUnsupport.GetSerializedSize();
-        // uint32_t serialized = DoSendError (p, rerrUnsupport, rerrSize, ipv4Address, protocol);
+        // uint32_t rerrSize = rerrUnsupported.GetSerializedSize();
+        // uint32_t serialized = DoSendError (p, rerrUnsupported, rerrSize, ipv4Address, protocol);
         uint32_t serialized = 0;
         return serialized;
     }
